/**
 * Created by lanhao on 16/6/7.
 */

'use strict';

class requestEntity {
  constructor() {
    this.method = null;
    this.url = null;
    this.headers = null;
    this.query = null;
    this.body = null;
  };

  format() {
    let url = this.url;

    if (this.query) {
      url = url.includes('?') ? url : url + '?';
      for (let k in this.query) {
        url += '&' + k + '=' + this.query[k];
      }
    }

    let _o = {
      method: this.method,
      url: url,
      headers: this.headers
    };

    if (_o.headers && _o.headers['content-type'] && (_o.headers['content-type'] + '').includes('json')) {
      _o.json = this.body;
    } else {
      _o.form = '';
      for (let k in this.body) {
        _o.form += k + '=' + this.body[k] + '&';
      }
    }

    return _o;
  };

  hasMethod(method) {
    return ({
      'head': true,
      'get': true,
      'post': true,
      'put': true,
      'delete': true
    })[method];
  };
}

module.exports = requestEntity;